import { Component, EventEmitter, Output } from '@angular/core';
import { DataService } from 'src/services/data/data.service';
import { Weapon } from 'src/interfaces/weapon';
import { Damage } from 'src/interfaces/damage';
import { CdkDragDrop, moveItemInArray } from '@angular/cdk/drag-drop';
import { Spell } from 'src/interfaces/spell';

@Component({
  selector: 'spell-table',
  templateUrl: './spell-table.component.html',
  styleUrls: ['./spell-table.component.scss'],
})
export class SpellTableComponent {
  public constructor(public dataAccessor: DataService) {}

  @Output() public createNewSpell: EventEmitter<void> =
    new EventEmitter<void>();

  public spells!: Spell[];

  public ngOnInit(): void {
    this.spells = this.dataAccessor.getSpells();
  }

  public dropSpells(event: CdkDragDrop<string[]>): void {
    moveItemInArray(this.spells, event.previousIndex, event.currentIndex);
    this.updateSpells();
  }

  public updateSpells(): void {
    this.dataAccessor.setSpells(this.spells);
  }

  public createSpell(): void {
    console.log('createWeapon()');
    this.createNewSpell.emit();
  }

  public addSpell(spell: Spell) {
    this.spells.push(spell);
    this.updateSpells();
  }
}
