import { Component, EventEmitter, Output } from '@angular/core';
import { DataService } from 'src/services/data/data.service';
import { Weapon } from 'src/interfaces/weapon';
import { Damage } from 'src/interfaces/damage';
import { CdkDragDrop, moveItemInArray } from '@angular/cdk/drag-drop';

@Component({
  selector: 'weapon-table',
  templateUrl: './weapon-table.component.html',
  styleUrls: ['./weapon-table.component.scss'],
})
export class WeaponTableComponent {
  public constructor(public dataAccessor: DataService) {}

  @Output() public createNewWeapon: EventEmitter<void> =
    new EventEmitter<void>();

  public weapons!: Weapon[];

  public ngOnInit(): void {
    this.weapons = this.dataAccessor.getWeapons();
  }

  public dropWeapons(event: CdkDragDrop<string[]>): void {
    moveItemInArray(this.weapons, event.previousIndex, event.currentIndex);
    this.updateWeapons();
  }

  public updateWeapons(): void {
    this.dataAccessor.setWeapons(this.weapons);
  }

  public createWeapon(): void {
    console.log('createWeapon()');
    this.createNewWeapon.emit();
  }

  public addWeapon(weapon: Weapon) {
    this.weapons.push(weapon);
    this.updateWeapons();
  }
}
